!

!

FinoGeeks

Summary

The  Information  Age  has  essentially  drawn  to  a  close,  even  though  the  process  of

computerizing business, generating data, converting data into information, and distributing

it via networks will persist indeﬁnitely. The world has now transitioned into the Digital Age.

A  critical  question  confronts  enterprise  IT:  Can  legacy  software  architectures  from  the

Information Age continue satisfying the requirements of the Digital Age? A short answer

is NO.

Throughout  the  last  three  to  four  decades  of  information  technology  evolution,  the

conventional  software  engineering  approach  has  endured.  However,  it  has  become

increasingly apparent that this approach no longer aligns with the demands of the digital

age. The era that was inaugurated during the early stages of the mobile internet and the rise

of the App economy has now plateaued, exhibiting signs of weariness. Companies grapple

with the challenge of maintaining cost-eﬀectiveness in the development, maintenance, and

operation of their proprietary applications. IT productivity consistently lags behind market

demands, leaving business stakeholders dissatisﬁed.

In reality, IT has persistently grappled with:

1.  The  never-ending  cycle  of  creating  or  acquiring  new  systems,  leading  to  the

proliferation of information silos and an unceasing demand for connecting them.

2.  "Pseudo-agility"  or  "agility  theatre",  where  IT  teams  tout  adoption  of  agile

methodologies,  yet  fall  short  of  aligning  software  functionality  delivery  with  the

swift shifts in market dynamics and business needs.

3.  Inability  to  achieve  proportional  IT  productivity  scalability  despite  added

personnel  and  budgets,  consistently  drawing  business  complaints  over

imperceptible progress.

1

FinoGeeks

In the digital age, software and architecture diﬀer signiﬁcantly from the information age,

demanding  adaptation  for  competitiveness.  It's  time  for  a  breakthrough  in  IT,  where

software forms and architectures must evolve beyond the information age.

The future of enterprise digital software is SuperApp - a software paradigm for the digital

era.

2

FinoGeeks

Contents

SUMMARY ...................................................................................................................... 1

1.  KEY CONCEPTS ........................................................................................................ 4

2.  APP 1.0 – SOFTWARE PARADIGM IN THE INFORMATION AGE ............................... 9

3.  APP 2.0 - SOFTWARE FORMS IN THE DIGITAL AGE ............................................... 14

4.  WORKING THEORY BEHIND SUPERAPPS .............................................................. 21

5.  ECONOMIES OF SCALE FOR DIGITAL TRANSFORMATION ..................................... 25

3

FinoGeeks

1. Key Concepts
 HTML5: Encompassing HTML, JavaScript, CSS and related web technologies. For the

public  it  means  webpages,  for  mobile  developers  it  means  code  snippets  using  these

technologies, usually embedded in apps.

App: The standard software form on smartphones since the mobile internet era. Though

formats and standards vary on iOS, Android, etc., they are software running on mobile

devices, by nature indiﬀerent from their PC counterparts.

Native App: Analogous to Windows desktop software developed in C++, Visual Basic,

Pascal  etc.  Mobile  apps  use  languages  like  Objective-C,  Swift,  Kotlin,  Java,  C,  C++

supported by OS vendors.

Hybrid  App:  For  diverse  OSes  like  iOS  and  Android,  the  same  business  logic  needs

redeveloping with diﬀerent tech, necessitating larger teams, longer cycles and inconsistent

user experience across devices. Cross-platform solutions emerged using technologies like

Flutter,  React  Native  to  build  app  foundations  portable  across  OSes,  and  HTML5  for

adaptable, business-focused, frequently-changed content.

SuperApp:  A  class  of  Apps  like  WeChat  and  Alipay  transcend  traditional  software

boundaries by becoming platforms, running millions of 3rd party code known as “Mini-

App” or “Mini-program” securely within themselves, covering all aspects of life, harnessing

massive business and societal resources, constructing digital worlds where users can largely

reside without returning oﬀline. Elon Musk praises such apps and aims to remake Twitter

4

FinoGeeks

(now X) this way. Gartner's 2023 Tech Trends report dubs them SuperApp - no longer

exclusive to internet giants and now entering enterprises.

Mini-App/Mini-program:  Around  2017,  WeChat

introduced  "Mini-program"

technology. This was instrumental to WeChat becoming a SuperApp - Mini-programs have

low development barriers, great mobile user experience, and can harness resources across

society,  serving  as  an  enabler  of  "digitalization".  Subsequently,  other  Internet  giants

followed  suit,  developing  similar  Mini-program  syntax,  formats  and  runtimes,  releasing

their  own  Mini-program  technologies  to  compete  for  internet  ecosystem  share.  By

leveraging  societal  resources  through  Mini-programs,  these  platforms  aim  to  emulate

WeChat's  success  as  a  SuperApp.  In  2021,  W3C  formed  a  group  to  standardize  Mini-

programs  and  called  them  Mini-Apps.  In  this  paper,  “Mini-App”  and  “Mini-program”

terms are used interchangeably.

W3C  Mini-App  Workgroup:  With  the  tremendous  success  of  Mini-programs,  more

vendors participate, establishing this W3C group to standardize Mini-programs.

SuperApp Enabling Tech for Enterprise: Internet giants have obtained huge business

value  through  their  proprietary  Mini-program  technologies  and  centrally  controlled

SuperApp  platforms.  In  contrast,  enterprises  across  industries  and  even  government

agencies have been relegated to becoming passive ecosystem members on these external

SuperApp platforms. Commercial organizations and government bodies long for similar

technologies to attain autonomy - to assume platform operator roles, construct and govern

their  own  digital  ecosystems,  accumulate  their  own  data,  and  safeguard  operational  and

customer data privacy. Fortunately, SuperApp technologies have now been standardized

for  enterprise  adoption,  enabling  organizations  to  emulate  the  practices  of  internet

SuperApps, independently harnessing Mini-Apps to build their own digital platforms and

ecosystems.

5

FinoGeeks

FinClip  Mini-App  Spec:  The  Mini-program  technology  independently  deﬁned  and

developed by FinoGeeks maintains compatibility with mainstream internet Mini-programs

in  formats,  interfaces,  and  speciﬁcations.  This  enables  enterprise  IT  to  reuse  existing

technical investments and talent, as well as leverage the sizeable stock of Mini-program

content  resources  in  society.  It  also  supports  related  W3C  standards,  empowering

enterprises through standardized technologies.

FinClip Mini-program Runtime: FinoGeeks, currently the sole independent vendor in

this domain, commenced developing comprehensive Mini-program technology in 2019. It

enables enterprises of any scale to cost-eﬀectively obtain capabilities previously exclusive

to internet giants, building their own SuperApps and digital ecosystems.

FinClip Security Sandbox: All Mini-program code is downloaded from the internet and

executed  on-demand.  To  ensure  that  this  code  poses  no  potential  security  risks  to  user

devices, FinClip employs a secure sandbox technology within its runtime environment to

isolate and execute Mini-program code. This sandbox also isolates any communication or

sharing between Mini-programs.

FinClip  SDK:  FinoGeeks  encapsulates  the  aforementioned  Mini-program  runtime  and

secure sandbox technology within an SDK. This SDK oﬀers support for various operating

systems, including iOS, Android, Windows, Mac, Linux, and more. To enable the capability

of running Mini-programs within any existing app, integration of this SDK requires just a

few lines of code.

FinClip  SuperApp:  A  SuperApp  built  with  the  FinClip  SDK,  capable  of  operating

unlimited Mini-Apps/Mini-programs.

Host App: In relation to Mini-programs, an App—whether it is entirely native or hybrid

in nature—becomes a host for running Mini-programs once integrated with the FinClip

SDK. This can be likened to virtualization technology, where the virtual machine is the

6

FinoGeeks

guest, and the operating system running the virtual machine is the host. Mini-programs

"reside" within the host. FinoGeeks' FinClip technology extends the concept of "host" to

PC operating systems, IoT devices, and more. Therefore, strictly speaking, the host is not

limited  to  mobile  Apps,  although  in  this  context,  unless  speciﬁed  otherwise,  it  can  be

assumed to refer to regular Apps.

Mini-program  container  technology:  isolates  each  Mini-program  within  its  secure

sandbox, allowing individual instances to run independently in their dedicated memory,

threads, and storage and making them invisible to one another, akin to placing each Mini-

program  instance  within  its  own  "container".  This  containerization  is  key  to  achieving

economies of scale for SuperApps.

Mini-program Runtime Lifecycle: When a Mini-program instance is loaded into the host,

its various states such as initialization, visibility, invisibility, and destruction are collectively

referred to as the "Lifecycle." State transitions are typically triggered by user interactions

within the host.

Mini-program Publishing Lifecycle: The various stages a Mini-program goes through,

including development, testing, grayscale/canary release (partial deployment), production

release (full deployment), and termination, collectively constitute its "publishing status."

Host Lifecycle: For mobile devices like smartphones and tablets, the host app lifecycle is

typically associated with the mobile operating system and the app stores operated by mobile

manufacturers.  It's  important  to  note  that  the  "Mini-program  publishing  lifecycle"  is

entirely separate from the host's publishing lifecycle. Mini-program developers and host

developers  may  have  no  connection,  which  is  a  key  factor  in  achieving  SuperApp

economies of scale (as discussed later).

Zero Trust: A security model ﬁrst proposed by Forrester Research analyst John Kindervag

in  2010,  departing  from  traditional  IT  security  models  focused  on  protecting  network

7

FinoGeeks

perimeters and assuming everything inside is trusted. Zero trust presumes no implicit trust

in any person or device inside or outside networks.

8

FinoGeeks

2. App 1.0 – So7ware Paradigm in the Informa@on Age
The information age represented the transition from the isolated computerization age to

an interconnected age enabling information exchange.

1.  Computerization  or  Electronization:  In  this  phase,  exempliﬁed  by  banks,  various

business processes are gradually transformed into software systems. During this period,

software  systems  primarily  run  on  isolated,  non-networked  computing  devices  (such  as

Mainframes). At this stage, there is only data, and information is yet to be fully realized.

2. Informatization: With the emergence of network technologies, the 1990s saw the gradual

formation  of  a  global  internet.  Previously  isolated  computers  now  transmit  their

computational results over networks, transforming them into information. During the Web

1.0 era, the internet connected these computers with remote users, breaking geographical

barriers and facilitating interactions. Information primarily ﬂowed from the inside to the

outside.

The  advent  of  mobile  internet  and  the  rise  of  the  app  economy  haven't  fundamentally

altered the software development models in use since the mainframe, Client/Server, and

PC eras. Enterprise IT still adheres to old paradigms in terms of development philosophy

and technical architecture. As a result, app development inherits most of the traditional

software development problems.

Software Planned Economy Results in Agile Theatre

Software development guided by the "planned economy" mindset of the information age

cannot be truly agile. The one-way, inside-out development model entails internal business

9

FinoGeeks

departments  initiating  feature  requests,  then  IT  analysing  and  planning  those  features,

either building them internally per plan or outsourcing development, followed by repetitive

in-house testing cycles. After bundled features and ﬁxes are deemed ready, IT packages a

release and submits it to third-party app stores, with the goal of getting external users to

download and install. This unidirectional approach is extremely slow and clumsy with high

time costs, coarse granularity, and inability to meet urgent business needs to reach markets

swiftly. IT’s self-proclaimed “agility” doesn’t help.

The digital age calls for ﬁne-grained capabilities, fast development and release, rapid low-

cost  trial-and-error,  and  completely  controllable  risks.  Software  is  "utility  computing"  -

users utilise on-demand then move on. The "planned economy" mindset cannot satisfy

these demands.

Waste IT Cycles of inﬁnite connect, disconnect, connect…

IT oscillates between perpetually "creating information silos" and attempting to "connect

them". New systems are continually acquired and developed, with each addition resulting

in more silos. Past integration eﬀorts using ESBs (Enterprise Service Buses), messaging

middleware etc. were costly and minimally eﬀective. Business stakeholders often cannot

grasp or quantify the beneﬁts, thus remain dissatisﬁed. Enterprises are forever tackling

information silos.

Digitalization  necessitates  people,  scenarios,  activities,  processes  and  transactions  being

online with intersystem interconnection. Information silos run counter to digitalization's

fundamental prerequisite of openness and connectivity.

Lacking of Operational Flexibility

IT-developed  apps  often  lack  what  we  could  term  "operational  ﬂexibility"  from  the

business perspective. In fact, over the past three to four decades of computerization and

informatization,  not  just  apps  -  most  software  systems  have  faced  similar  inﬂexibility,

unable to meet business units' operational needs.

10

FinoGeeks

Many  software  systems  attempt  to  address  this  by  implementing  mechanisms  like

"management  backends,"  which  allow  business  users  some  degree  of  control,  enabling

them  to  conﬁgure  parameters  and  rules  independently,  without  needing  to  request  IT's

assistance  for  every  new  requirement  that  wasn't  considered  during  the  initial  software

design phase. However, these "management backend" mechanisms often lack the ﬂexibility

needed for applications primarily aimed at external customers or partners (especially mobile

apps). They struggle to meet the demands of timely and rapidly changing operational needs.

In simpler terms, apps that continue to follow the software mindset of the information age

often fall short of embracing the "digitally operational" mindset.

The  requirements  of  the  digital  age  are  characterized  by  a  strong  demand  for  high

timeliness, the need to reach users via the internet, and a business department's reluctance

to  wait  for  IT's  development  schedules.  Business  users  aspire  to  have  control  over  the

creation and publication of digital content, especially in marketing-focused business lines

where direct customer engagement through company software becomes essential.

IT Productivity Cannot Scale

IT  perennially  grapples  with  understaﬀing,  leaving  business  departments  perpetually

dissatisﬁed with IT support. Even with limitless budgets and personnel, can IT genuinely

deliver linear or near-linear productivity growth relative to human resources invested? This

perennial question leaves business-side and senior management perplexed about where all

the IT investment goes.

In  the  realm  of  software  development,  throwing  in  more  people  doesn’t  necessarily

translate to heightened productivity. What is the root cause?

11

FinoGeeks

It  lies  in  the  technical  architecture.  Traditional  IT  often  employs  tightly-coupled

architectures,  similar  to  a  conﬁned  physical  space  in  a  small  house  where  additional

personnel oﬀer limited manoeuvrability. Mobile apps, constrained by device form factors,

exemplify such "palm-sized spaces" where adding engineers proves unproductive.

The digital age necessitates businesses to embrace loosely-coupled technical architectures,

where  "Lego"-like  functional  modules  dynamically  assemble  to  meet  customer  needs.

These modules possess low or no interdependence, enabling disparate individuals, teams,

and departments to work independently in parallel. Apps become portals for assembling

prefabricated components, embodying the ethos of "more hands, lighter work."

Self-imposed limitation obstructing true openness

Enterprises  are  habitually  conditioned  to  presume  rigid  software  boundaries,  struggling

with openness. Stuck in information age mindsets, most enterprises still think along the

lines  of  "initiating  internal  business  requests"  -  "planning  and  designing  systems"  -

"outsourcing to developers to build and test" - "conducting users acceptance test to obtain

online approval from business units" – "upgrading entire system to go live". This inside-

out,  one-way  thinking  strongly  assumes  software  serving  customers  must  be  natively

developed and operated by the enterprise itself. Though many tout "openness", it's mostly

lip service. How to open up? What signiﬁes openness? How to ensure a secured openness?

12

FinoGeeks

It’s  easy  said  than  done  but  devil  is  in  the  details.  Where  are  the  necessary  tools,  best

practices and actual implementation solutions?

Digitalization  necessitates  disrupting  traditional  physical  boundaries,  redeﬁning  digital

edges.  Digitally  advanced  ﬁrms  rethink  internal/external  network  boundaries  -  internal

software cannot presume safety, while external services must ensure security. Firms must

utilize  technical  intermediaries  (telcos,  internet  traﬀic  platforms,  third  parties)  to  reach

customers externally, while enabling trusted exchange of digital resources (source code)

with partners internally.

Enterprise software development, procurement, and operations are no longer necessarily

entirely in-house activities. In the digital age, embracing interconnectedness and symbiotic

relationships between organizations is indispensable for enterprises to thrive.

13

FinoGeeks

3. App 2.0 - So7ware Forms in the Digital Age
The aforementioned problems have been aptly resolved, speciﬁcally manifest in SuperApps.

The SuperApp tech trend spearheaded by internet giants has actualized the concepts and

user experiences of Web 2.0 that traditional enterprise IT largely missed out on. It's now

opportune to institute similar practices in traditional enterprises. Let's delve into how the

various  problems  associated  with  the  earlier  Informatization  era's  Software  1.0  can  be

addressed one by one.

Market Economy Driven Software Paradigm

SuperApps  with  Mini-programs  represent  a  "market  economy"  software  development

paradigm that architecturally enables dynamic fulﬁlment of unpredictable, challenging-to-

plan business needs.

Business  demands  are  endless  while  market  conditions  rapidly  shift.  But  the  one-way

thinking  of  traditional  IT  makes  ensuring  business  innovation  and  time-to-market

extremely diﬀicult, possibly due to:

1. Business functional requirements may be uncertain, with trial-and-error aspects.

IT may overinvest in potentially misguided eﬀorts, proven wasteful months later

upon market launch.

2. Analysis by personnel of business requirements also risks being incomplete or

misguided. In the software 1.0 era, IBM recommended dedicating 50% of project

time to requirements analysis, but few enterprises actually achieve this. Incorrect

14

FinoGeeks

analysis,  coupled  with  typical  enterprise  communication  disconnects  and

misalignments, lead to deviation between software intent and implementation.

3.  Months-long  implementation  schedules  hinder  responding  to  market  changes,

rendering previously reasonable designs ineﬀective upon launch.

The solution is controlling capability granularity - develop one capability and immediately

release  it,  making  business  capability  releases  extremely  aﬀordable.  This  enables  rapid

development and staged rollouts with quick experimentation in controlled scopes through

rapid iterations and rapid launch.

SuperApp enabling technologies, capable of aggregating unlimited number of ﬁne-grained

business scenarios encapsulated in Mini-programs, provide such a solution. The completely

decoupled yet complementary SuperApp "Host Lifecycle" and Mini-program "Publishing

Lifecycle"  enable  long-term  host  stability  with  frequently-changing  Mini-program

development,  testing  and  release.  Mainstream  internet  SuperApps  have  proven  this

ﬂexibility  -  the  largest  platforms  release  hundreds  of  thousands  of  Mini-programs  with

millions of publishing and removals daily without issues.

Moreover, SuperApp operators do not need to predict what future business capabilities to

support. The Mini-program mechanism mobilizes societal resources across industries for

endless  digital  scenarios  and  developer  contributions.  New,  unplanned  and  innovative

business  capabilities  will  just  appear  seamlessly.  Compared  to  software  1.0's  "Planned

Economy" driven engineering paradigm, this exempliﬁes "Market Economics". In fact, the

mobile internet era's app stores pioneered such bona ﬁde software market dynamics, now

ripe for enterprises.

An enterprise operating its own Mini-programs Marketplace actualizes digital ecosystem

and modularization, delivering on-demand granular capabilities, powering true agility.

15

FinoGeeks

“Core Business+” Strategy

SuperApp with Mini-programs, akin to the 'Internet+' strategy, serve as a core capability

that transcends various application scenarios, bridging information silos. For instance, a

bank  can  employ  its  core  capabilities,  such  as  accounts,  KYC,  credit,  and  payments,  to

establish a 'Banking+' strategy. Through a banking SuperApp, it can leverage these core

capabilities and introduce various 'Mini-program' commercial scenarios sitting on top of

the core capability APIs. If the Mini-programs are provided by external 3rd parties partners,

then bank is now essentially orchestrating a very viable Open Banking strategy.

While this approach doesn't entirely solve the problem of 'information silos' inherited from

the information age – enterprise IT may still require message middleware, enterprise service

buses,  etc.,  to  integrate  internal  systems  –  using  the  SuperApp  technology  platform  to

connect  multiple  scenarios  and  parties  represents  another  means  of  breaking  down

information silos. This approach is often the most tangible and direct way for business

departments, partners, and customers to perceive improved digital capabilities. Users' most

immediate experience of a company's 'digital' prowess is having a single app that can handle

all their business needs without going oﬀline.

Better yet, the SuperApp approach is essentially leveraging the Internet itself as the service

bus  to  connect  services  from  both  internal  systems  and  external  partner  systems  for  a

customer.

IT Is the Platform While Business Run on The Platform

SuperApp with Mini-programs can form a highly operable business platform. With such a

platform,  enterprises  can  appoint  operational  teams  or  even  establish  dedicated  digital

operations departments as owners and managers. They are responsible for orchestrating

the collaboration among internal business departments, industry chain partners, and third-

party collaborators, eﬀectively acting as a platform operator. This means promoting and

enticing  internal  and  external  parties  to  'join'  the  platform,  transforming  their  business

scenarios into Mini-programs, and providing Mini-program content to the platform.

16

FinoGeeks

In this context, if business departments and partners are the 'publishers' of Mini-program

content,  the  platform  itself  becomes  the  'distributor'  responsible  for  the  ﬁnal  review,

management  of  listings,  and  operations  on  the  platform's  associated  apps  (such  as

placement, user recommendations, and search functionality).

Boost IT Productivity with Elasticity

SuperApp with Mini-programs enable large-scale parallel development within enterprises,

eliminating the need for 'scheduling' business department demands. Enterprise IT should

contemplate  and  draw  lessons  from  why  certain  internet  companies'  SuperApps  can

seamlessly accommodate millions of developers working concurrently without interference

with each other, allowing them frequent uploading and removing of various content. If a

company's IT possesses such capabilities, could it organize numerous teams to develop in

parallel and address various demands from diﬀerent business departments simultaneously?

Imagine a scenario where the CEO states that leveraging technology to support business

is top priority and in urgent need, willing to allocate funds and resources immediately but

wanting  to  see  results  as  quickly  as  possible.  IT  can  conﬁdently  pledge  to  increase

productivity almost linearly—for instance, by temporarily augmenting external engineering

talent to achieve the kind of resource elasticity akin to cloud services.

17

FinoGeeks

These abilities are imperative for any enterprise IT, not just internet BigTech companies.

Sometimes  the  greatest  concern  isn't  a  lack  of  funds  or  personnel  but  rather  investing

resources without visible IT outputs.

Openness For Better Leverage

SuperApp  with  Mini-programs,  in  their  open  and  integrated  approach,  redeﬁne  a

company's  digital  boundaries.  Enterprises  provide  services  to  customers  and  partners

through software, but this 'software' no longer necessarily originates from the enterprise

itself. The integration and exchange of online digital resources may not always be IT-driven;

it's  increasingly  a  business  endeavour.  Business  units  can  introduce  external  partners,

launch their digital services, leverage third-party services for their customers, and conduct

transactions  through  revenue  sharing  or  resource  exchange.  This  process  often  doesn't

18

FinoGeeks

involve IT departments procuring third-party digital services, as these third-parties may not

even be software providers and don't meet the conditions for selling software.

Furthermore,  lightweight  software  in  Mini-program  form  becomes  an  online  digital

resource that can be forwarded, shared, circulated and ﬂowed to customers. It runs within

an enterprise's app, but this doesn't imply that its source code was developed or procured

by the enterprise's IT department for deployment.

In summary, a SuperApp is not a simple replacement for traditional apps; it's fundamentally

an  open  platform  that  is  made  possible  with  Mini-programs.  With  robust  security

mechanisms,  IT  technically  operates  and  maintains  the  platform  while  business

departments  handle  'business  development'  on  the  platform  by  attracting  partners  and

facilitating collaborations, by bringing in partners’ Mini-programs to the company’s self-

hosted “Mini-program store”.

IT becomes the platform itself.

Conclusion: Capabilities of App 2.0

These capabilities constitute the foundations of next-gen enterprise software essential for

digital transformation across industries in the post-mobile internet era.

The emergence of generative AI technology may herald the arrival of a software 3.0 era,

but has this era truly arrived? According to Andrej Karpathy, Director of AI at Tesla and

former OpenAI scientist, it hasn't yet. Generative AI with natural language programming

capabilities introduces a new layer of abstraction, allowing you to instruct it to generate

software using human language. However, these generated artifacts remain fundamentally

2.0 products.

The technological architecture of SuperApps along with Mini-programs embodies a divide-

and-conquer  algorithmic  approach.    It  is  sensible  to  currently  focus  on  judiciously

19

FinoGeeks

leveraging  it  to  decompose  immense  complex  business  problems  into  isolated  pieces,

applying  low-code/no-code  and  generative  AI  locally.  This  pragmatic  targeting  of

generative AI on component problems within the overarching SuperApp + Mini-program

architecture may prove more realistic.

20

FinoGeeks

4. Working Theory Behind SuperApps
SuperApp technology is not a simple "replacement" for traditional apps. At minimum, it

comprises:

1.  Client-side:  FinClip  SDK  by  FinoGeeks  (see  deﬁnitions)  embeds  SuperApp

frontends into existing mobile apps on iOS, Android, etc, as well as Linux, Windows,

Mac OS, and even IoT and low-power device screens, enabling ubiquitous Mini-

programs.

2.  Mini-Apps Store/Marketplace: This is a tool for enterprises to deploy and operate

their  own  Mini-program  management  system.  It  allows  companies  to  centrally

manage Mini-program content from both their internal teams and external partners,

including  content  review,  publishing,  retraction,  and  monitoring.  The  external

digital  ecosystem  of  the  enterprise  relies  on  this  system  for  its  operation.

Additionally, the most important user-facing function is to provide mechanisms for

discovering  and  showcasing  Mini-program  content,  such  as  user  access  through

search, recommendations, rankings, and more.

3.  Mini-App publishing, staged rollout, and developer portal: SuperApp serves as an

open platform where developers can register developer accounts, upload, update,

and  retract  their  developed  Mini-program  content.  Developers  can  also  set  rules

and strategies for gradual releases to control the scope of content deployment and

the target user groups.

4.  Data monitoring tools: Collect and analyze Mini-program runtime and usage data

within the SuperApp to help enterprises optimize operational strategies.

21

FinoGeeks

The key points are the client-side SDK to embed Mini-program capabilities everywhere,

the enterprise marketplace to manage Mini-programs, developer portals for creating Mini-

programs, and data tools to optimize SuperApp ecosystem operations.

Moreover, to facilitate the streamlined creation of Mini-program-style digital content by

enterprise  IT  and  its  partners,  FinoGeek's  FinClip  technology  also  oﬀers  tools  such  as

FinClip  Studio  and  FinClip  Browser.  These  tools  make  it  convenient  for  developers  to

create and debug Mini-programs.

SuperApp technology is Cloudiﬁcation

"Cloudifying"  app  capabilities  on  client  devices  transcends  "form  factor"  constraints,

unshackling  IT  productivity.  As  discussed  earlier,  the  traditional  app  conﬁned  to  the

phone’s minuscule palm-sized space" can be likened to a 10 sqft. room - adding more IT

engineers  is  unavailing  in  the  cramped  space,  more  business  requests  still  await  in  a

serialised long queue pending for sequential IT development. When faced with especially

urgent  and  crucial  business  demands,  the  business  departments,  as  particular  software

feature  "owners,"  often  have  to  approach  IT  to  increase  priority  levels  or  even  seek

intervention from company senior management. In such a congested space, the idea of

openness becomes almost impossible.

22

FinoGeeks

The solution entails retaining basic, core, stable functionality (e.g. biometrics, video, digital

payments, stock trading etc.) in the 10 sqft. room, while shifting business scenario content

to  the  unbounded  space  of  the  cloud.  Mini-programs  make  this  achievable  -  each

independently  developed,  debugged,  published,  monitored  on  the  cloud-side,  then

seamlessly  loaded  into  an  device-side  App  when  required.  This  architecture  enables  a

constrained  device-side  host  app  in  the  minuscule  space  to  accommodate  an  unlimited

number of teams and individuals oﬀering endless business possibilities.

SuperApp technology is Zero-Trust

As  elucidated  earlier,  enterprise  digital  boundaries  are  redeﬁned  in  the  digital  era,  with

interconnectedness  and  openness  between  an  enterprise  and  partners  epitomizing

digitalization. No bona ﬁde platforms or digital ecosystems exist sans openness. So how

do successful internet SuperApps open up and ingest digital content including source code

from countless entities devoid of security qualms? The crux is Zero Trust - trust nobody’s

code and always employing security sandboxing to sequester partner source code (Mini-

programs),

insulating

interactions  between  Mini-program

instances,

insulating

23

FinoGeeks

communication between Mini-programs and their host app and insulating Mini-program

access to local device resources.

In truth, no enterprise IT team or software project today can eschew depending on open-

source technologies, hence cannot presume the nested layers of open-source dependencies

are devoid of vulnerabilities or tainted code. The most prudent strategy is for enterprise

SuperApp platforms to espouse zero trust irrespective of any partner or even their own IT.

"Zero trust" permits secure openness to construct digital ecosystems. (Note: this borrows

concepts from the Zero Trust security model - refer to deﬁnitions at the outset.)

24

FinoGeeks

5. Economies of Scale for Digital Transforma@on

Today,  across  various  industries,  there  is  a  push  for  the  digital  economy  and  digital

transformation. While concepts and theories abound, how can enterprises concretely put

the slogan of "digital transformation" into practice? How can they make their customers,

partners, employees palpably feel it? In a sense, it means entering "App 2.0" by embracing

secure  openness  and  ecosystem  interconnections  to  codify  everything  into  software.

"Software is eating the world", Marc Andreessen proclaimed in the Wall Street Journal on

August 20, 2011.

But “Talk is cheap. Show me the code."

SuperApp  technology  is  exactly  such  a  “killer  technology”  that  renders  “digitalization”

intuitively perceptible and catalyzes snowball eﬀects for enterprise digital transformation –

just consider how digitalization has climbed to current heights in China, made tangible and

accessible  to  the  general  public,  with  some  “national-grade”  or  so-called  “citizen”

SuperApps  playing  decisive  roles.  Government  and  enterprises  should  emulate  such

successful practices within their own vertical realms.

The cardinal reason SuperApp technology can accelerate digitalization is by virtue of the

aforementioned “cloudiﬁcation” and “zero trust” mechanisms, it makes digitalization of

discrete  scenarios  highly  viable.  The  technical  platform  achieves  economy  of  scale,

equivalent to mobilizing an unlimited number of societal resources online, thereby further

accelerating  the  online  transformation  of  more  societal  resources.  In  comparison,

traditional  apps  on  smartphones  cannot  achieve  this  because,  for  the  vast  majority  of

enterprises, the professional threshold and economic cost of developing, operating, and

25

FinoGeeks

running an app themselves are much higher than those of a Mini-program running within

a SuperApp.

Quantitative  change  drives  qualitative  change  –  when  social  resources  and  business

scenarios become highly easy to codify, extremely rich and diverse software ecosystems

emerge,  eventually  encompassing  everything,  furnishing  consumers  nearly  all  required

services in the virtual realm. Is this not the most palpable digitalization?

Now, SuperApp technology no longer remains exclusive privilege of any internet giants or

BigTech  companies.  It  is  time  for  commercial  and  government  entities  to  adopt  this

enabling  technology  to  build  their  interlinked  world  with  supply  chain  partners,  online

customers, and suitable societal resources, and to position themselves as platform owners

to  function  as  platforms  within  their  own  business  realms.  From  the  perspective  of

openness, interconnection and ecosystem, SuperApps are the most eﬀicacious medium for

numerous institutions to undertake their own digitalization.

26

